# (c) Copyright IBM Corp. 2005, 2011 All rights reserved.
# This [ ] scripts are owned by International Business Machines Corporation or
# one of its subsidiaries ("IBM") and is copyrighted and licensed, not sold.
# You may copy, modify, and distribute this script in any form without
# payment to IBM, for any purpose including developing, using, marketing or
# distributing programs that include or are derivative works of the script.
# The script provided to you on an "AS IS" basis, without warranty of
# any kind. IBM HEREBY EXPRESSLY DISCLAIMS ALL WARRANTIES, EITHER
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE. IBM shall not be liable for indemnification or any damages you 
# suffer as a result of using, modifying or distributing the script or its
# derivatives. Each copy of any portion of this script or any derivative work,
# must include the above copyright notice and disclaimer of warranty.
#
print 'Starting configureAudit.py script ...\n'

#-------------------------------------------------------------------------------
# Enable audit and set ID/pwd
#-------------------------------------------------------------------------------

try:
    AdminTask.enableAudit()
    AdminTask.setAuditorId('-name wsadmin')
    AdminTask.setAuditorPwd('-password s3cur1ty')
    print "Audit enabled and auditor ID/pwd set\n"
except:
    print "Enabling audit caught an exception"
    print (sys.exc_type)
    print (sys.exc_value)


#-------------------------------------------------------------------------------
# Delete all filters and create just AUTHZ filter
#-------------------------------------------------------------------------------

try:
    allFilters = AdminTask.listAuditFiltersByRef()   
    filters = allFilters.replace(" ", ",")
    print "listAuditFiltersByRef completed successfully\n"
    print "The filters found are:"
    print filters
    split_filter = filters.split(',')
    print "size of filter list is: "
    print len(split_filter)
except:
    print "AdminTask.listAuditFiltersByRef caught an exception"
    print (sys.exc_type)
    print (sys.exc_value)    
    
try:
    for filter_item in split_filter:
        print "filter to delete is: "
        print filter_item
        if len(filter_item) != 0:
           AdminTask.deleteAuditFilterByRef('-filterRef ' + filter_item)   
           print "deleteAuditFilterByref completed successfully\n"
except:
    print "AdminTask.deleteAuditFilterByref caught an exception"
    print (sys.exc_type)
    print (sys.exc_value)    


try:
    outcomesAuthn = AdminTask.getAuditOutcomes('-eventType SECURITY_AUTHN')
    if outcomesAuthn.find("SUCCESS") != -1 and outcomesAuthn.find("INFO") != -1 and outcomesAuthn.find("WARNING") != -1 and outcomesAuthn.find("ERROR") != -1 and outcomesAuthn.find("DENIED") != -1 and outcomesAuthn.find("REDIRECT") != -1 and outcomesAuthn.find("FAILURE") != -1 :
        print "Audit filter for SECURITY_AUTHN already set\n"
    else :
        filterRefAuthn = AdminTask.createAuditFilter('-name authn -eventType SECURITY_AUTHN -outcome "SUCCESS, INFO, WARNING, ERROR, DENIED, REDIRECT, FAILURE"')
        print "Audit filter created for SECURITY_AUTHN\n"
        addfilters = filterRefAuthn
except:
    print "AdminTask.getAuditOutcomes for SECURITY_AUTHN caught an exception"
    print (sys.exc_type)
    print (sys.exc_value)    
    
try:
    outcomesAuthn_deleg = AdminTask.getAuditOutcomes('-eventType SECURITY_AUTHN_DELEGATION')
    if outcomesAuthn_deleg.find("SUCCESS") != -1 and outcomesAuthn_deleg.find("INFO") != -1 and outcomesAuthn_deleg.find("WARNING") != -1 and outcomesAuthn_deleg.find("ERROR") != -1 and outcomesAuthn_deleg.find("DENIED") != -1 and outcomesAuthn_deleg.find("REDIRECT") != -1 and outcomesAuthn_deleg.find("FAILURE") != -1 :
        print "Audit filter for SECURITY_AUTHN_DELEGATION already set\n"
    else :
        filterRefAuthn_deleg = AdminTask.createAuditFilter('-name deleg_runAs -eventType SECURITY_AUTHN_DELEGATION -outcome "SUCCESS, INFO, WARNING, ERROR, DENIED, REDIRECT, FAILURE"')
        print "Audit filter created for SECURITY_AUTHN_DELEGATION\n"
        addfilters = addfilters + ',' + filterRefAuthn_deleg
except:
    print "AdminTask.getAuditOutcomes for SECURITY_AUTHN_DELEGATION caught an exception"
    print (sys.exc_type)
    print (sys.exc_value)    
    
try:
    outcomesTerm = AdminTask.getAuditOutcomes('-eventType SECURITY_AUTHN_TERMINATE')    
    if outcomesTerm.find("SUCCESS") != -1 and outcomesTerm.find("INFO") != -1 and outcomesTerm.find("WARNING") != -1 and outcomesTerm.find("ERROR") != -1 and outcomesTerm.find("DENIED") != -1 and outcomesTerm.find("REDIRECT") != -1 and outcomesTerm.find("FAILURE") != -1 :
        print "Audit filter for SECURITY_AUTHN_TERMINATE already set\n"        
    else :
        print "Audit filter not needed for SECURITY_AUTHN_TERMINATE\n"
except:
    print "AdminTask.getAuditOutcomes for SECURITY_AUTHN_TERMINATE caught an exception"
    print (sys.exc_type)
    print (sys.exc_value)    
    
try:
    outcomesAuthz = AdminTask.getAuditOutcomes('-eventType SECURITY_AUTHZ')
    if outcomesAuthz.find("SUCCESS") != -1 and outcomesAuthz.find("INFO") != -1 and outcomesAuthz.find("WARNING") != -1 and outcomesAuthz.find("ERROR") != -1 and outcomesAuthz.find("DENIED") != -1 and outcomesAuthz.find("REDIRECT") != -1 and outcomesAuthz.find("FAILURE") != -1 :
        print "Audit filter for SECURITY_AUTHZ already set\n"
    else :
        filterRefAuthz = AdminTask.createAuditFilter('-name authz -eventType SECURITY_AUTHZ -outcome "SUCCESS, INFO, WARNING, ERROR, DENIED, REDIRECT, FAILURE"')
        print "Audit filter created for SECURITY_AUTHZ\n"
        addfilters = addfilters + ',' + filterRefAuthz
except:
    print "AdminTask.createAuditFilter for SECURITY_AUTHZ caught an exception"
    print (sys.exc_type)
    print (sys.exc_value)    
    
try:
    outcomesResource = AdminTask.getAuditOutcomes('-eventType SECURITY_RESOURCE_ACCESS')
    if outcomesResource.find("SUCCESS") != -1 and outcomesResource.find("INFO") != -1 and outcomesResource.find("WARNING") != -1 and outcomesResource.find("ERROR") != -1 and outcomesResource.find("DENIED") != -1 and outcomesResource.find("REDIRECT") != -1 and outcomesResource.find("FAILURE") != -1 :
        print "Audit filter for SECURITY_RESOURCE_ACCESS already set\n"
    else :
        print "Audit filter not needed for SECURITY_RESOURCE_ACCESS\n"
except:
    print "AdminTask.getAuditOutcomes for SECURITY_RESOURCE_ACCESS caught an exception"
    print (sys.exc_type)
    print (sys.exc_value)
    
try:
    outcomesAudit = AdminTask.getAuditOutcomes('-eventType SECURITY_MGMT_AUDIT')
    if outcomesAudit.find("SUCCESS") != -1 and outcomesResource.find("INFO") != -1 and outcomesResource.find("WARNING") != -1 and outcomesResource.find("ERROR") != -1 and outcomesResource.find("DENIED") != -1 and outcomesResource.find("REDIRECT") != -1 and outcomesResource.find("FAILURE") != -1 :
        print "Audit filter for SECURITY_MGMT_AUDIT already set\n"
    else :
        filterRefMgmtAudit = AdminTask.createAuditFilter('-name authz -eventType SECURITY_MGMT_AUDIT -outcome "SUCCESS, INFO, WARNING, ERROR, DENIED, REDIRECT, FAILURE"')
        print "Audit filter created for SECURITY_MGMT_AUDIT\n"
        addfilters = addfilters + ',' + filterRefMgmtAudit
except:
    print "AdminTask.getAuditOutcomes for SECURITY_MGMT_AUDIT caught an exception"
    print (sys.exc_type)
    print (sys.exc_value)       


#-------------------------------------------------------------------------------
# Add audit filters to default emitter and event factory
#-------------------------------------------------------------------------------

try:
    AdminTask.setAuditEmitterFilters('-emitterRef AuditServiceProvider_1173199825608 -filtersRef ' + addfilters + '\'')
    AdminTask.setAuditEventFactoryFilters('-eventFactoryRef AuditEventFactory_1173199825608 -filtersRef ' + addfilters + '\'')
    print "Filters added to emitter and event factory\n"
except:
    print "AdminTask.setAuditEmitterFilters/AdminTask.setAuditEventFactoryFilters caught an exception"
    print (sys.exc_type)
    print (sys.exc_value)
    print "Filters may already be set in default emitter and event factory\n"

#-------------------------------------------------------------------------------
# Add audit custom property 
#-------------------------------------------------------------------------------

try:
    AdminTask.modifyAuditEmitter('-emitterRef AuditServiceProvider_1173199825608 -customProperties ["com.ibm.websphere.security.commoncriteria.audit=true"]')
    print "Property added to emitter \n"
except:
    print "AdminTask.modifyAuditEmitter caught an exception"
    print (sys.exc_type)
    print (sys.exc_value)

#-------------------------------------------------------------------------------
# Save changes
#-------------------------------------------------------------------------------

AdminConfig.save()

print 'The configureAudit.py script is done. Exiting wsadmin...\n'
